    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>
        <div class="marpit"><svg data-marpit-svg="" viewBox="0 0 1280 5000"><foreignObject width="1280" height="5000"><section id="1" data-marpit-fragments="22">
<h1>Tests</h1>
<p>В этом задании веб-приложение уже написано. Вам предстоит написать интеграционные тесты, которые будут проверять работу этого приложения. Интеграционное тестирование — это такой тип тестирования, при котором отдельные модули объединяются и тестируются вместе, как группа. Интеграционные тесты проверяют, как эти модули работают вместе.</p>
<p>В этом задании есть только одна реализация — правильная, и она должна пройти тестирование. Мы не будем автоматически тестировать ваши тесты, подставляя неправильные реализации приложения.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="http://kong.github.io/unirest-java/">Пример POST-запроса, выполненного при помощи HTTP клиента Unirest</a></li>
<li data-marpit-fragment="2"><a href="https://junit.org/junit5/docs/5.0.0/api/org/junit/jupiter/api/BeforeAll.html">Аннотация @BeforeAll — указывает, что метод, помеченный этой аннотацией, выполняется перед всеми тестами в этом классе</a></li>
<li data-marpit-fragment="3"><a href="https://junit.org/junit5/docs/5.0.0/api/org/junit/jupiter/api/AfterAll.html">Аннотация @AfterAll — указывает, что метод, помеченный этой аннотацией, выполняется после всех тестов в этом классе</a></li>
<li data-marpit-fragment="4"><a href="https://javadoc.io/doc/io.javalin/javalin/latest/io/javalin/Javalin.html#start()">Метод start() — запускает приложение Javalin</a></li>
<li data-marpit-fragment="5"><a href="https://javadoc.io/doc/io.javalin/javalin/latest/io/javalin/Javalin.html#stop()">Метод stop() — останавливает приложение</a></li>
<li data-marpit-fragment="6"><a href="https://javadoc.io/doc/io.javalin/javalin/latest/io/javalin/Javalin.html#port()">Метод port() — возвращает порт, на котором запущено приложение</a></li>
</ul>
<h2>src/test/java/exercise/AppTest.java</h2>
<p>Для проверки работы приложения в тестах мы будем отправлять ему запросы и проверять ответы. Поэтому перед началом всех тестов нужно запустить приложение, а после окончания всех тестов остановить его.</p>
<p>Часть тестов для приложения уже написана. Уже проверяется работа исходной страницы приложения, вывод всех пользователей, вывод конкретного пользователя и вывод формы создания пользователя. Вам предстоит проверить корректность работы приложения при создании нового пользователя. Нужно будет протестировать два сценария:</p>
<ul>
<li data-marpit-fragment="7">
<p>Позитивный — что при отправке валидных данных пользователь создаётся и добавляется в базу данных</p>
</li>
<li data-marpit-fragment="8">
<p>Негативный — что при отправке невалидных данных новый пользователь не создаётся</p>
</li>
</ul>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="9">
<p>Создайте метод, который перед началом тестов запускает приложение. Чтобы указать, что метод должен выполниться перед всеми тестами в классе, используйте аннотацию <code>@BeforeAll</code>. В методе получите экземпляр приложения, использовав статический метод <code>getApp()</code> из класса <code>App</code> и запишите полученный экземпляр в свойство <code>app</code> класса.</p>
<pre><code class="language-java">app = App.getApp();
</code></pre>
<p>Запустите приложение при помощи метода <code>start()</code> на случайном порту. Получите порт, на котором запустилось приложение, затем сформируйте базовый URL и запишите его в свойство <code>baseUrl</code> класса.</p>
<pre><code class="language-java">baseUrl = <span class="hljs-string">&quot;http://localhost:&quot;</span> + port;
</code></pre>
<p>Именно по этому URL мы будем обращаться к приложению в тестах</p>
</li>
<li data-marpit-fragment="10">
<p>Создайте метод, который после завершения всех тестов остановит приложение. Чтобы указать, что метод должен выполниться после всех тестов в классе, используйте аннотацию <code>@AfterAll</code></p>
</li>
<li data-marpit-fragment="11">
<p>Изучите уже написанные тесты. Обратите внимание на комментарии к коду.</p>
</li>
<li data-marpit-fragment="12">
<p>Напишите тест, который проверяет, что при отправке валидных данных приходит ответ с кодом 302, а новый пользователь создаётся и добавляется в базу данных. Данные пользователя считаются валидными, если:</p>
<ul>
<li data-marpit-fragment="13">Имя и фамилия не пустые</li>
<li data-marpit-fragment="14">Email валидный (состоит из двух частей — имени ящика и доменного имени почтового сервиса, разделенных знаком <em>@</em>)</li>
<li data-marpit-fragment="15">Пароль содержит не менее 4 символов</li>
</ul>
<p>Чтобы проверить, что пользователь с такими данными есть в базе, получите его из базы и проверьте, что его данные соответствуют тем, что были отправлены в запросе.</p>
</li>
<li data-marpit-fragment="16">
<p>Напишите тест, который проверяет, что при отправке не валидных данных приходит ответ с кодом 422 и новый пользователь не добавляется в базу данных. Проверьте также, что тело ответа содержит данные пользователя и сообщения об ошибочно заполненных полях. Текст сообщений вы можете посмотреть в классе контроллера <code>UserController</code>.</p>
</li>
<li data-marpit-fragment="17">
<p>Если считаете, что необходимо дополнительно протестировать ещё какие-то случаи, можете написать тесты и на них.</p>
</li>
</ul>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="18">
<p>Метод <code>field()</code> библиотеки Unirest служит для установки значения поля в запросе</p>
</li>
<li data-marpit-fragment="19">
<p>Метод <code>getBody()</code> возвращает тело ответа в виде строки</p>
</li>
<li data-marpit-fragment="20">
<p>Метод <code>getStatus()</code> возвращает код ответа</p>
</li>
<li data-marpit-fragment="21">
<p>Чтобы проверить, что значение точно соответствует ожидаемому, используйте метод <code>isEqualTo()</code></p>
<pre><code class="language-java">assertThat(actual).isEqualTo(expected);
</code></pre>
</li>
<li data-marpit-fragment="22">
<p>Чтобы проверить равно ли значение <code>null</code>, используйте методы <code>isNull()</code> и <code>isNotNull()</code></p>
<pre><code class="language-java">assertThat(value).isNotNull();
assertThat(value).isNull();
</code></pre>
</li>
</ul>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  
